/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BytesLike,
  CallOverrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../common";

export interface HelperInterface extends utils.Interface {
  functions: {
    "getBlockNumber()": FunctionFragment;
  };

  getFunction(nameOrSignatureOrTopic: "getBlockNumber"): FunctionFragment;

  encodeFunctionData(
    functionFragment: "getBlockNumber",
    values?: undefined
  ): string;

  decodeFunctionResult(
    functionFragment: "getBlockNumber",
    data: BytesLike
  ): Result;

  events: {};
}

export interface Helper extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: HelperInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    getBlockNumber(overrides?: CallOverrides): Promise<[BigNumber]>;
  };

  getBlockNumber(overrides?: CallOverrides): Promise<BigNumber>;

  callStatic: {
    getBlockNumber(overrides?: CallOverrides): Promise<BigNumber>;
  };

  filters: {};

  estimateGas: {
    getBlockNumber(overrides?: CallOverrides): Promise<BigNumber>;
  };

  populateTransaction: {
    getBlockNumber(overrides?: CallOverrides): Promise<PopulatedTransaction>;
  };
}
